#!/bin/bash
NUM=26
WSPATH=/opt/Websense/
REPLACEFILES=(EIMServer libWsEventLog.so NetworkAgent)
NEWFILES=(natuning.ini)
STAMP=$(date +%F_%H.%M.%S)
LOGFILE=HFApplyLog_${NUM}_${STAMP}.txt
HFBACKUP=HFBackup_${NUM}_${STAMP}

function ApplyHotfix {
if [ ! -e $WSPATH ]; then
 echo Searching for installation...
 WSAPATH=$(find / -name "WebsenseAdmin" 2> /dev/null)
 FLAGNOTFOUND=1
 for DIRPATH in $WSAPATH; do
  CURPATH=${DIRPATH%/WebsenseAdmin}
  if [ -d $CURPATH/bin ]; then
   WSPATH=$CURPATH
   FLAGNOTFOUND=0
  fi
 done
 if [ $FLAGNOTFOUND == 1 ]; then
  echo Websense installation could not be found.
  exit -3;
 fi
fi

echo Websense installation found at $WSPATH, applying hotfix $NUM

if [ ! -w ${WSPATH/bin} ]; then
 echo You need super user privs.
 exit -2;
fi

$WSPATH/WebsenseAdmin stop

if [ -d $WSPATH/$HFBACKUP ]; then
 rm -rf $WSPATH/$HFBACKUP
fi

echo Creating backup.
mkdir $WSPATH/$HFBACKUP
for FILE in ${REPLACEFILES[*]}; do
 if [ -e $WSPATH/bin/$FILE ]; then
  mv $WSPATH/bin/$FILE $WSPATH/$HFBACKUP
  cp ./$FILE $WSPATH/bin/
 fi
done

echo Updating files.
for FILE in ${NEWFILES[*]}; do
 cp -f ./$FILE $WSPATH/bin/
done

$WSPATH/WebsenseAdmin start
exit -1
}
ApplyHotfix 2>&1
#| tee $LOGFILE
