'Author: C&SRT
'Date: 6.25.2008
'Written For: WWF 7.0, 7.0.1, 7.1

Option Explicit
On Error Resume Next
Dim objShell, objProcess, objWMIService, objWMIService2, colListOfServices, colListOfServices2, objService, objService2, colProcessList
Dim InstallPathKey
Dim InstallPath
Dim filesys
Dim binDir
Dim hfDir
Dim filesToReplace
Dim i, j, k
Dim backupFolder
Dim newFolder
Dim HFNumber
Dim servicesToStop
Dim timeWaited
Dim servicePollingInterval, serviceWaitTimeBeforeKill
Dim processName, pathNameParts, pathNameParts2
Dim servicePath, serviceState
Dim logFile, logFileName, objFile
Dim retryFileOverwrite
'Please modify these for the particular hotfix this script is for
HFNumber = 26
filesToReplace=Array("EIMServer.exe", "EIMService.dll", "WsEventLog.dll", "NetworkAgent.exe")
servicesToStop=Array("WebsenseMuxService", "WebsenseCAMReportServer", "WebsenseWFReportServer", _
						"WebsenseLinkingService", "DBManagerScheduler", "WebsenseCPMCommunicationAgent", _
						"WebsenseCAMServer", "WebsenseClientDeployService", "WebsenseIntegrationService", "Websense NetCache Service", _
						"WebsenseDCAgent", "WebsenseRADIUSAgent", "WebsenseeDirectoryAgent", "WebsenseXIDAuthenticationServer",_
						"Websense Network Agent", "Websense EIM Server", "WebsenseUserService", "WebsenseUsageMonitor", _
						"Websense Reporter Scheduler", _
						"WebsenseCommunicationAgent", "WebsenseLogServer", "WebsensePolicyServer", "WebsensePolicyBroker")
servicePollingInterval=5000
serviceWaitTimeBeforeKill=servicePollingInterval * 30
retryFileOverwrite=5000

'No ned to modify anything below here

Set objShell=CreateObject("WScript.Shell")
Set filesys=CreateObject("Scripting.FileSystemObject")

InstallPathKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Websense\InstallPath"

InstallPath=objShell.RegRead(InstallPathKey)

If InstallPath="" Then
	WScript.Echo "A Websense installation was not detected on this system."
	WScript.Quit 1
End If

binDir=InstallPath & "\bin\"
backupFolder = binDir & "HF" & HFNumber & "Backup"

If Not filesys.FolderExists(backupFolder) Then
	set newfolder = filesys.CreateFolder(backupFolder)
End If

logFileName="HFApplyLog_" & Month(Date) & "-" & Day(Date) & "-" & Year(Date) & "-" & Timer & ".txt"
Set objFile = filesys.CreateTextFile(backupFolder & "\" & logFileName)

message("")
message("******Applying Hotfix " & HFNumber & "******")
message("")

'Stop Services
'message("Stopping Services..."

For Each i in servicesToStop
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colListOfServices = objWMIService.ExecQuery ("Select * from Win32_Service Where Name ='" & i & "'")
	
	For Each objService in colListOfServices
		servicePath=objService.PathName
		serviceState=objService.State
		
		If not serviceState = "Stopped" Then
			message("Stopping " & i & "...")
			objService.StopService()
		
			timeWaited=0
			
			Do While not serviceState = "Stopped"
				If timeWaited > serviceWaitTimeBeforeKill Then
					pathNameParts=split(servicePath, ".exe")
					pathNameParts2=split(pathNameParts(0), "\")
					processName=pathNameParts2(ubound(pathNameParts2)) & ".exe"
					
					Set objWMIService2 = GetObject("winmgmts:{impersonationLevel=impersonate,(debug)}\\.\root\cimv2")
					Set colProcessList = objWMIService2.ExecQuery ("Select * From Win32_Process Where Name = '" & processName & "'")
					For Each objProcess in colProcessList
						message(i & "service failed to stop. Killing " & processName & "...")
						objProcess.Terminate()
					Next
				End If
				message("Waiting for " & i & " to stop...")
				WScript.Sleep(servicePollingInterval)
				timeWaited=timeWaited+servicePollingInterval
			
				Set colListOfServices2 = objWMIService.ExecQuery ("Select * from Win32_Service Where Name ='" & i & "'")
				
				For Each objService2 in colListOfServices2
					serviceState=objService2.State
				Next
			Loop
		Else
			message(i & " is already stopped.")
		End If
	Next
Next

'Backup & replace binaries
hfDir=filesys.GetAbsolutePathName(".")
message(" ")
message("Backing up old binaries & replacing with Hotfix binaries...")

'Need to copy natuning on its own because it DNE already in bin
message("Copying " & hfDir & "\" & "natuning.ini" & " to " & binDir & " IF it does not already exist")
filesys.CopyFile hfDir & "\" & "natuning.ini", binDir & "natuning.ini", false

For Each j in filesToReplace
	If filesys.FileExists(binDir & j) Then
		message("Found " & j)
		message("Backing up " & binDir & j & " to " & backupFolder)
		message("Version: " & filesys.GetFileVersion(binDir & j))
		filesys.CopyFile binDir & j, backupFolder & "\" & j, false
		message("Copying " & hfDir & "\" & j & " to " & binDir)
		filesys.CopyFile hfDir & "\" & j, binDir & j, true
		
		Do While not filesys.GetFileVersion(binDir & j)=filesys.GetFileVersion(hfDir & "\" & j)
			message(j & " was not copied successfully. Version does not match hotfix version: " & filesys.GetFileVersion(hfDir & "\" & j))
			message(" ")
			message("Waiting for " & j & " to become overwritable...")
			WScript.Sleep(retryFileOverwrite)
			message("Trying to copy " & j & " again...")
			message("Copying " & hfDir & "\" & j & " to " & binDir)
			filesys.CopyFile hfDir & "\" & j, binDir & j, true
		Loop
		message("")
		
	Else
		message(binDir & j & " NOT Found")
	End If
Next

'Start services in the reverse order in which they were stopped
For k=ubound(servicesToStop) to 0 Step - 1
	Dim serviceToStart
	serviceToStart=servicesToStop(k)
	
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colListOfServices = objWMIService.ExecQuery ("Select * from Win32_Service Where Name ='" & serviceToStart & "'")
	
	For Each objService in colListOfServices
		message("Starting " & serviceToStart & "...")
		objService.StartService()
		serviceState=objService.State
		
		Do While not serviceState = "Running"
			message("Waiting for " & serviceToStart & " to start...")
			WScript.Sleep(servicePollingInterval)
		
			Set colListOfServices2 = objWMIService.ExecQuery ("Select * from Win32_Service Where Name ='" & serviceToStart & "'")
			
			For Each objService2 in colListOfServices2
				serviceState=objService2.State
			Next
		Loop
	Next
Next

objFile.close

Sub message(theMessage)
	WScript.Echo(theMessage)
	objFile.WriteLine(theMessage)
End Sub
	
	
